package com.example.course.controller;

import cn.hutool.core.util.IdUtil;
import cn.hutool.core.util.IdcardUtil;
import cn.hutool.json.JSONUtil;
import com.baomidou.mybatisplus.annotation.IdType;
import com.example.course.dto.KafkaDto;
import com.example.course.utils.DateUtils;
import com.example.course.utils.RedisUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.kafka.core.KafkaTemplate;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
@RequestMapping("/kafka")
@EnableScheduling
public class KafkaController {
    @Autowired
    private RedisUtil redisUtil;
    @Autowired
    private KafkaTemplate<String,String> kafkaTemplate;
    @PostMapping("/send")
    @Scheduled(cron = "0 * * * * *")
    public void send(){
        //redis格式化订单
        String yyMMddHHmmss = DateUtils.getDateTimeNum();
        String num = redisUtil.getStartNum(yyMMddHHmmss);
        num = num += 1;
        String orderNo = yyMMddHHmmss + num;
        System.err.println(orderNo);
        KafkaDto kafkaDto = new KafkaDto();
        kafkaDto.setMsgId("123698745");
        kafkaDto.setContent("消息内容");
        kafkaDto.setMsgType("消息类型");
        kafkaTemplate.send("zxcv",JSONUtil.toJsonStr(kafkaDto));
    }
}
